#include <stdio.h>
#include <stdlib.h>
#include <sys/types.h>
#include <fcntl.h>
#include <sys/stat.h>
#include <sys/mman.h>
#include <unistd.h>
#include <errno.h>
#include "tund.h"


int debug=0;
Seq *stun;


int main(int argc,char **argv)
 {
  char **p;
  int i;
  int ret;

  p=argv;
  while(*p)
   {
    if(strcmp(*p,"-d")==0)
     debug=1;
    p++;
   }
  if(debug)
   {
    printf("Entering debug mode\n");
    tund_lock();
   }
  else
   {
    /*to daemon*/
    printf("To daemon...\n");
    ret=fork();
    if(ret<0)
     {
      perror("Can not fork");
      exit(1);
     }
    if(ret)
     exit(0);

    /*Child*/
    freopen("/dev/null","r",stdin);
    freopen("/dev/null","w",stdout);
    freopen("/dev/null","w",stderr);

    for(i=3;i<getdtablesize();i++)
     close(i);

    if(setsid()<0)
     Error("setsid: %s",strerror(errno));
    tund_lock();
   }

  stun=seq_new();
  if(parse_config())
   {
    Log("Error while parsing config file");
    exit(1);
   }

  init_rng();
  init_secur();
  init_alarm();

  do_it();
 }

