#include <stdlib.h>
#include <sys/types.h>
#include <md5.h>
#include "tund.h"


extern int debug;


unsigned char *get_md5_hash(unsigned char *data, int len)
 {
  MD5_CTX ctx;
  static unsigned char *hash;

  MD5Init(&ctx);
  MD5Update(&ctx,data,len);
  hash=(unsigned char*)malloc(16);
  bzero(hash,16);
  MD5Final(hash,&ctx);
  return hash;
 }



unsigned char *get_str_md5_hash(char *str)
 {
  return get_md5_hash(str,strlen(str));
 }



unsigned int get_str_4b_hash(char *str)
 {
  union
   {
    unsigned char hash[16];
    struct
     {
      unsigned int d1;
      unsigned int d2;
      unsigned int d3;
      unsigned int d4;
     } n;
   } buf;
  unsigned char *hash;
  unsigned int ret;

  hash=get_str_md5_hash(str);
  bcopy(hash,&buf,16);
  ret=buf.n.d1^buf.n.d2^buf.n.d3^buf.n.d4;
  return ret;
 }



unsigned short get_str_2b_hash(char *str) {
  union
   {
    unsigned int lh4;
    struct
     {
      unsigned short d1;
      unsigned short d2;
     } n;
   } buf;
  unsigned short ret;

  buf.lh4=get_str_4b_hash(str);
  ret=buf.n.d1^buf.n.d2;
  return ret;
 }


