
#include <stdlib.h>
#include <stdio.h>
#include <unistd.h>
#include <fcntl.h>
#include <sys/types.h>
#include <sys/time.h>
#include <string.h>
#include <openssl/rsa.h>
#include "tund.h"


static char hostname[128];
static RSA *rsa_priv=NULL;
static unsigned char *rsa_pub=NULL;
static unsigned int len_rsa_pub=0;


int main(int argc,char **argv)
 {
  FILE *f;
  int ret;
  unsigned char key[8192];
  unsigned int n;
  int len;
  RSA *rsa;
  unsigned char *p;
  int i;

  if(argc<2)
   {
    printf("Usage: %s private_key_file\n",argv[0]);
    exit(1);
   }

  bzero(hostname,128);
  ret=gethostname(hostname,127);

  f=fopen(argv[1],"r");
  if(!f)
   {
    printf("Can not open %s\n",argv[1]);
    exit(1);
   }
  bzero(key,8192);
  len=0; 
  do
   {
    ret=fscanf(f,"%2x",&n);
    if(ret!=1) break;
    key[len]=n;  
    len++; 
   } while(len<8190);
  printf("Read %d bytes as RSA private key\n",len);
  fclose(f);

  p=key;
  rsa=d2i_RSAPrivateKey(&rsa_priv,&p,(long)len);
  if(!rsa || !rsa_priv)
   {
    printf("Error while d2i_RSAPrivateKey\n");
    exit(1);
   }
  
  len_rsa_pub=i2d_RSAPublicKey(rsa_priv,NULL);
  printf("i2d_RSAPublicKey returns %d\n",len_rsa_pub);
  rsa_pub=(unsigned char*)malloc(len_rsa_pub);
  if(!rsa_pub) 
   {
    printf("Can not allocate %d bytes for RSA pk\n",len_rsa_pub);
    exit(1);
   }
  bzero(rsa_pub,len_rsa_pub);
  p=rsa_pub;
  i2d_RSAPublicKey(rsa_priv,&p);

  f=fopen(RSAPUBKEY_FILE,"w");
  if(!f)
   {
    printf("Can not open %s\n",RSAPUBKEY_FILE);
    exit(1);
   }
  fprintf(f,"%s ",hostname);
  for(i=0;i<len_rsa_pub;i++)
   {
    fprintf(f,"%02x",rsa_pub[i]);
   }
  fprintf(f,"\n");
  fclose(f);
  printf("Done.\n");
  exit(0);
 }

