
#include <stdlib.h>
#include <stdio.h>
#include <unistd.h>
#include <fcntl.h>
#include <sys/types.h>
#include <sys/time.h>
#include <string.h>
#include <openssl/rsa.h>
#include "tund.h"


static char hostname[128];


void kgf_cb(int n,int num,void *arg)
 {
  char c;

  c=n==0?'-':(n==1?'=':(n==2?'+':'*'));
  printf("%c",c);
  if(n==3)
   printf("\n");
  fflush(stdout);
 }


int main(int argc,char **argv)
 {
  RSA *rsa;
  int keylen;
  int ret;
  FILE *f;
  int fd;
  int i;
  unsigned char *pp,*p;
  struct timeval tp;
  unsigned int n;
  double dn;

  if(argc==2)
   keylen=atoi(argv[1]);
  else
   keylen=1024;

  printf("Generating new %d bits RSA key:\n",keylen);

  ret=gettimeofday(&tp,NULL);
  if(ret)
   {
    printf("Can not get time.\n");
    exit(1);
   }

  RAND_seed(&tp,sizeof(tp));

  rsa=RSA_generate_key(keylen,3,kgf_cb,NULL);
  if(!rsa)
   {
    printf("Error while RSA_generate_key.\n");
    exit(1);
   }

  f=fopen(RSAKEY_FILE,"w");
  if(f<0)
   {
    printf("Can not open rsa_priv.key\n");
    exit(1);
   }
  ret=i2d_RSAPrivateKey(rsa,NULL);
  printf("i2d_RSAPrivateKey returns %d\n",ret);
  pp=(unsigned char*)malloc(ret);
  bzero(pp,ret);
  p=pp;
  ret=i2d_RSAPrivateKey(rsa,&pp);
  for(i=0;i<ret;i++)
   {
    fprintf(f,"%02x",p[i]);
   }
  fclose(f);


  /*Now generating RNG seed*/
  printf("Generating RND seed\n");
  fd=open(SEED_FILE,O_CREAT|O_WRONLY|O_TRUNC,0644);
  if(fd<0)
   {
    perror("Can not get time");
    exit(1);
   }
  ret=gettimeofday(&tp,NULL);
  if(ret)
   {
    printf("Can not get time.\n");
    exit(1);
   }
  srand48(tp.tv_usec);
  do
   {
    dn=drand48();
    n=(int)(9689.0*dn);
   }while(n==0 || n==9689);
  printf("F=%d\n",n);
  ret=write(fd,&n,4);
  if(ret!=4)
   {
    perror("Can not create seed file");
    exit(1);
   }
  for(i=0;i<9689;i++)
   {
    n=lrand48();
    ret=write(fd,&n,4);
    if(ret!=4)
     {
      perror("Can not write seed");
      exit(1);
     }
   }
  close(fd);
 }

